# ANOTATED RPM SPEC FILE

# set release number (increment with each new build release)
%define releasebase 3
# set base page name 
%define nbase fftpack
# define AFS defines here (only used if "--with afs" is given to rpmbuild):
%define afsarch amd
%define afsroot /afs/cad/hpc

#Use as deafults if no command line inputs
%define as_limulus 1
# NOTE: compilers are mutually exclusive, only set one,
#       if not using command line options
#       !not all compilers have been implemented and tested!
#       gnu4 is now default
%define use_gnu4  1
%define use_gnu3 0
%define use_pgi  0
%define use_intel 0
%define use_pathsc 0

# >>>End of basic user defines area<<<

# allow --with[out] <feature> at rpm command line build
%{?_with_gnu3: %{expand: %%define use_gnu3 1}}
%{?_with_gnu4: %{expand: %%define use_gnu4 1}}
%{?_with_pgi: %{expand: %%define use_pgi 1}}
%{?_with_intel: %{expand: %%define use_intel 1}}
%{?_with_pathsc: %{expand: %%define use_pathsc 1}}
%{?_with_basement: %{expand: %%define as_basement 1}}
%{?_with_limulus: %{expand: %%define as_limulus 1}}
%{?_with_afs: %{expand: %%define as_afs 1}}
#pick the target
%if "1" == "%{as_basement}"
%define targetbase Basement
%define prefix /opt/fftpack/%{version}
%else
%if "1" == "%{as_afs}"
%define targetbase afs_%{afsarch}
%define prefix %{afsroot}/%{afsarch}/opt/fftpack/%{version}
%define  _defaultdocdir	%{afsroot}/%{afsarch}/%{_usr}/share/doc
%else
%define targetbase Limulus
%define prefix /opt/fftpack/%{version}
%endif
%endif

# Begin RPM defines for package

Version:  5.0
License: GPL
Group: %{targetbase}/Libraries
Release: %{releasebase}.%{targetbase}
Summary: Fast Fourier Transform library
URL: http://www.cisl.ucar.edu/css/software/fftpack5/index.html
Packager: deadline@basement-supercomputing.com
Vendor: Basement-Supercomputing.com
Source:  fftpack5.zip
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Requires: modules
BuildRequires: modules
Patch0: fftpack5-Makefile.patch

# Account for possible compiler options
# This does not mean this build will support
# all these compilers, check the build sections below
# Often compler names or flags are set here, in 
# the case of fftpack the Makefile handles 
# the different compilers and options.

%if "1" == "%{use_pgi}"
Name: %{nbase}-pgi
%define buildprefix %{prefix}/pgi
%define modprefix pgi
%define makeprefix  pgi
%else
%if "1" == "%{use_intel}"
Name: %{nbase}-intel
%define modprefix intel
%define buildprefix %{prefix}/intel
%define makeprefix intel
%else
%if "1" == "%{use_pathsc}"
Name: %{nbase}-pathsc
%define modprefix pathsc
%define buildprefix %{prefix}/pathsc
%else
%if "1" == "%{use_gnu3}"
Name: %{nbase}-gnu3
%define modprefix gnu3
%define makeprefix gnu
%define buildprefix %{prefix}/gnu3
%else
Name: %{nbase}-gnu4
%define modprefix gnu4
%define makeprefix gnu4
%define buildprefix %{prefix}/gnu4
%endif
%endif
%endif
%endif



%description
A package of Fortran subprograms for calculating    
fast Fourier transforms for both complex and real  
periodic sequences and certain other symmetric 
sequences


%prep
%setup -n  %{nbase}5
%patch0 -p0

%build
# Build requires Basement modules package to be installed
# Only supports PGI otherwise 
%if "1" == "%{use_pgi}"
       . /etc/profile.d/modules.sh
  	module load pgi62
%endif

make %{makeprefix}

%install
# make sure we include the fortran incude file
/bin/mkdir -p $RPM_BUILD_ROOT/%{buildprefix}/lib
/bin/cp libfftpack.a $RPM_BUILD_ROOT/%{buildprefix}/lib
/bin/cp README $RPM_BUILD_ROOT/%{buildprefix}/lib

%post
# this gets done on installation
/sbin/ldconfig 2>/dev/null
#create the module file
cat <<EOF >/opt/Modules/modulefiles/fftpack-%{modprefix}
#%Module1.0#######################################################################
## fftpack modulefile
##

proc ModulesHelp { } {
        puts stderr "\tThis module loads the appropriate environment for "
        puts stderr "\tusing fftpack-%{modprefix} version %{version}.\n"
}

module-whatis "fftpack-%{modprefix} %{version}"
module-log error none

set fftpackroot %{prefix}/%{modprefix}

if [ module-info mode load ] {
	setenv FFTPACK_PATH \$fftpackroot/lib
}
if [ module-info mode remove ] {
	unsetenv FFTPACK_PATH 
}
EOF

%postun
# This gets done when un-installing
/sbin/ldconfig 2>/dev/null
# remove the module file 
/bin/rm /opt/Modules/modulefiles/fftpack-%{modprefix}

%clean
# this gets done when the build is over
%{__rm} -rf %{buildroot}

%files
%defattr(-, root, root, 0755)
%doc README fftpack5.pdf
%{buildprefix}/lib/libfftpack.a
%{buildprefix}/lib/README

%changelog
* Thu Jul 22 2010 -  deadline@basement-supercomputing.com
- modified for AFS install  and new Modules
